package generics;

import java.util.ArrayList;

public class SetGeneric<T extends Object>{
    private final ArrayList<T> places;
    public int getCount() {
        return places.size();
    }
    private final int maxCount;
    public SetGeneric(int count){
        maxCount = count;
        places = new ArrayList<>();
    }
    public boolean insert(T ship){
        if(places.size() == maxCount)
            return false;
        return insert(ship, 0);
    }
    public boolean insert(T ship, int position){
        if (!(position >= 0 && position <= places.size() && places.size() < maxCount))
            return false;
        places.add(position, ship);
        return true;
    }
    public boolean remove(int position){
        if(!(position >= 0 && position < places.size()))
            return false;
        places.remove(position);
        return true;
    }
    public T get(int position){
        if(!(position >= 0 && position < places.size()))
            return null;
        return places.get(position);
    }
    public ArrayList<T> getShips(){
        return new ArrayList<>(places);
    }
}